<template>
  <a-cascader :value="selectValue" :options="mccList" placeholder="选择行业编码" @change="changeFunc" />
</template>
<script lang="ts" setup>
import { defineProps, defineEmits, computed } from 'vue'
import mccJSON from './mccTerpay.json'

// 定义组件的传入参数 
const props = defineProps({
    value: { type: String, default: '' },
    merchantType: { type: Number, default: 1 }
})

// emit： 向父组件进行通讯。 
const emit = defineEmits(['update:value'])

// 行业列表
let mccList = computed(() => {
  // merchantType 2：个体 3：企业 1：小微
   if (props.merchantType == 2){
    return mccJSON.individualList
  } else if (props.merchantType == 3){
    return mccJSON.enterpriseList
  } else {
    return mccJSON.smallBusinessesList
  }
})


// 计算属性 
const selectValue = computed(() => {
   if (props.value){
    return [queryOne(props.value), props.value]
  }
  return null
})

// 当属性发生了变化， 需要通过函数向父组件通信 --》 父组件再通知子组件进行数据的变化。 
function changeFunc(value){
  emit('update:value', value[1])
}

// 查找一级分类
function queryOne(val){
  let result = mccList.value.filter( (v) => {
    if(v.children){
        return v.children.filter( (v2) => v2.value == val).length > 0 
    }
    return false
  })

  return result.length > 0 ? result[0].value : null
}

</script>

